/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.ProdVigenciaDAO;
import com.rjconsultores.ventaboletos.entidad.ProdVigencia;
import com.rjconsultores.ventaboletos.entidad.ReservacionCtrl;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("prodVigenciaDAO")
public class ProdVigenciaHibernateDAO extends GenericHibernateDAO<ProdVigencia, Integer>
        implements ProdVigenciaDAO {

    @Autowired
    public ProdVigenciaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<ProdVigencia> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    @Override
    public List<ProdVigencia> buscarTraslapa(ProdVigencia prodVigencia) {
		Criteria c = this.getSession().createCriteria(ProdVigencia.class);
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.ge("fecvigenciafin", prodVigencia.getFecvigenciainicio()));
		c.add(Restrictions.le("fecvigenciainicio", prodVigencia.getFecvigenciafin()));
		c.add(Restrictions.eq("productoServicio", prodVigencia.getProductoServicio()));
		
		return c.list();
    }
}
